function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@xmweb-ui/vue-renderless/cascader-mobile/vue";
import { defineComponent, $prefix, $props, setup as _setup } from "@xmweb-ui/vue-common";
import { IconCheck, IconYes, IconLoading, IconCheckedSur, IconHalfselect, IconSearch, IconClose } from "@xmweb-ui/vue-icon";
import Button from "@xmweb-ui/vue-button";
import ActionSheet from "@xmweb-ui/vue-action-sheet";
import Exception from "@xmweb-ui/vue-exception";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import { t } from "@xmweb-ui/vue-locale";
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "flex items-start leading-6 py-3 cursor-pointer select-none",
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, [_vm.multiple ? _c(_vm.selected ? "icon-checked-sur" : "icon-check", {
    tag: "component",
    class: ["flex-none mt-1 mr-2", _vm.selected ? "fill-color-brand" : "fill-color-icon-disabled"],
    attrs: {
      "custom-class": "w-4.5 h-4.5"
    }
  }) : _vm._e(), _c("div", {
    class: ["flex-auto flex w-full text-sm", {
      "truncate": _vm.ellipsis
    }, {
      "text-color-brand": !_vm.multiple && _vm.selected
    }]
  }, [_vm._t("default", function() {
    return [_c("div", {
      class: ["flex-auto", {
        "truncate": _vm.ellipsis
      }]
    }, [_c("div", {
      staticClass: "flex"
    }, [_c("div", {
      class: [{
        "min-w-[theme(spacing.14)]": !_vm.textField3
      }, {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(" " + _vm._s(_vm.data[_vm.textField]) + " ")]), _vm.textField2 ? _c("div", {
      class: ["ml-5 text-color-text-placeholder", {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(" " + _vm._s(_vm.data[_vm.textField2]) + " ")]) : _vm._e()]), _vm.textField3 ? _c("div", {
      class: ["text-color-text-placeholder", {
        "truncate": _vm.ellipsis
      }]
    }, [_vm._v(" " + _vm._s(_vm.data[_vm.textField3]) + " ")]) : _vm._e()]), !_vm.loading && !_vm.multiple && _vm.selected ? _c("div", {
      staticClass: "flex flex-none w-5 items-center justify-center ml-2"
    }, [_c("IconYes", {
      staticClass: "fill-color-brand",
      attrs: {
        "custom-class": "w-5 h-5"
      }
    })], 1) : _vm._e(), _vm.option.loading ? _c("div", {
      staticClass: "flex flex-none w-5 items-center justify-center ml-2"
    }, [_c("svg", {
      staticClass: "animate-[spin_1.5s_linear_infinite] fill-current",
      attrs: {
        "viewBox": "25 25 50 50"
      }
    }, [_c("circle", {
      staticClass: "stroke-color-brand xm-loading-path",
      attrs: {
        "cx": "50",
        "cy": "50",
        "r": "24",
        "fill": "none"
      }
    })])]) : _vm._e()];
  })], 2)], 1);
};
var staticRenderFns$1 = [];
var __vue2_script$1 = {
  emits: ["click"],
  components: {
    IconCheck: IconCheck(),
    IconYes: IconYes(),
    IconLoading: IconLoading(),
    IconCheckedSur: IconCheckedSur(),
    IconHalfselect: IconHalfselect()
  },
  props: ["selected", "ellipsis", "multiple", "option", "textField", "textField2", "textField3", "loading"],
  computed: {
    data: function data() {
      return this.option.data || this.option;
    }
  }
};
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1, null, null, null);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var Option = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var $constants = {
  defaultNodeConfig: {
    lazy: false,
    load: null,
    isLeaf: "leaf",
    afterLoad: null,
    currentNodeKey: null,
    checkStrictly: false,
    checkDescendants: null,
    defaultCheckedKeys: null,
    defaultExpandedKeys: null,
    autoExpandParent: null,
    defaultExpandAll: null,
    filterNodeMethod: null
  }
};
var __vue2_script = defineComponent({
  name: $prefix + "CascaderMobile",
  emits: ["click", "search-click", "update:visible", "update:text"],
  components: {
    XmActionSheet: ActionSheet,
    XmOption: Option,
    XmButton: Button,
    XmException: Exception,
    IconCheck: IconCheck(),
    IconCheckedSur: IconCheckedSur(),
    IconHalfselect: IconHalfselect(),
    IconSearch: IconSearch(),
    IconClose: IconClose()
  },
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    data: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    modelValue: [Number, String, Array],
    visible: {
      type: Boolean,
      default: false
    },
    ellipsis: {
      type: Boolean,
      default: false
    },
    valueField: {
      type: String,
      default: "id"
    },
    placeholder: {
      type: [String, Array],
      default: t("ui.select.placeholder")
    },
    childrenField: {
      type: String,
      default: "children"
    },
    textField: {
      type: String,
      default: "label"
    },
    textField2: {
      type: String,
      default: ""
    },
    textField3: {
      type: String,
      default: ""
    },
    title: String,
    textSplit: {
      type: String,
      default: " / "
    },
    showHeader: {
      type: Boolean,
      default: true
    },
    showFooter: {
      type: Boolean,
      default: false
    },
    multiple: Boolean,
    searchConfig: {
      type: Object,
      default: function _default3() {
        return {
          options: [],
          searchMethod: null,
          openSearchSlot: false
        };
      }
    },
    nodeConfig: {
      type: Object,
      default: function _default4() {
        return $constants.defaultNodeConfig;
      }
    }
  }),
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.visible,
      expression: "visible"
    }],
    attrs: {
      "data-tag": "xm-cascader-mobile"
    }
  }, [_c("xm-action-sheet", {
    attrs: {
      "xm_mode": "mobile-first",
      "title": _vm.title,
      "show-footer": "",
      "visible": _vm.state.toggle,
      "show-header": !_vm.state.search.show,
      "custom-class": ["min-h-[95%] pb-4"]
    },
    on: {
      "update:visible": function updateVisible($event) {
        return _vm.$emit("update:visible", $event);
      },
      "close": _vm.close
    },
    scopedSlots: _vm._u([{
      key: "body-top",
      fn: function fn() {
        return [_c("div", {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: !_vm.state.search.show,
            expression: "!state.search.show"
          }],
          staticClass: "h-11 flex-none flex items-center border-b-0.5 border-color-border-separator overflow-auto whitespace-nowrap scrollbar-size-0"
        }, [_c("div", {
          staticClass: "px-4 flex"
        }, [_vm._l(_vm.state.computedNavList, function(option, index) {
          return _c("div", {
            key: index,
            staticClass: "flex-none flex"
          }, [index !== 0 ? _c("span", {
            staticClass: "px-2 text-color-text-placeholder"
          }, [_vm._v("/")]) : _vm._e(), _c("span", {
            class: ["flex-none max-w-[theme(spacing.24)] truncate", {
              "text-color-brand": index === _vm.state.level
            }, _vm.disabledNavOption(index, option) ? "text-color-text-disabled" : "cursor-pointer"],
            on: {
              "click": function click($event) {
                return _vm.setLevel(index, option);
              }
            }
          }, [_vm._v(_vm._s(option.data[_vm.textField]))])]);
        }), _c("div", {
          staticClass: "flex-auto"
        })], 2)])];
      },
      proxy: true
    }, {
      key: "header-left",
      fn: function fn() {
        return [_c("IconSearch", {
          staticClass: "cursor-pointer",
          attrs: {
            "custom-class": "h-5 w-5"
          },
          on: {
            "click": function click($event) {
              return _vm.searchBoxToggle(true);
            }
          }
        })];
      },
      proxy: true
    }, {
      key: "footer",
      fn: function fn() {
        return [_c("xm-button", {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: _vm.state.showButton,
            expression: "state.showButton"
          }],
          staticClass: "flex-1",
          attrs: {
            "xm_mode": "mobile-first",
            "type": "primary",
            "reset-time": 0
          },
          on: {
            "click": _vm.confirm
          }
        }, [_vm._v(_vm._s(_vm.t("ui.button.confirm")))])];
      },
      proxy: true
    }])
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.state.search.show,
      expression: "!state.search.show"
    }],
    staticClass: "flex-auto",
    attrs: {
      "data-tag": "tabs"
    }
  }, _vm._l(_vm.state.options, function(currentList, index) {
    return _c("div", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: index === _vm.state.level,
        expression: "index === state.level"
      }],
      key: index,
      staticClass: "flex flex-col px-4 overflow-auto pt-2",
      attrs: {
        "data-tag": "tab-item"
      }
    }, _vm._l(currentList, function(item, index2) {
      return _c("xm-option", {
        key: item.data[_vm.valueField],
        attrs: {
          "multiple": _vm.multiple,
          "ellipsis": _vm.ellipsis,
          "text-field": _vm.textField,
          "text-field2": _vm.textField2,
          "text-field3": _vm.textField3,
          "loading": _vm.state.loading,
          "option": item,
          "selected": _vm.isSelected(item)
        },
        on: {
          "click": function click($event) {
            return _vm.selectOption(item, $event);
          }
        }
      }, [_vm._t("default", null, {
        "item": item,
        "index": index2
      })], 2);
    }), 1);
  }), 0), _c("div", {
    class: [_vm.state.search.show ? "flex flex-col flex-auto" : "hidden"],
    attrs: {
      "data-tag": "search-box"
    }
  }, [_c("div", {
    staticClass: "flex leading-6 pt-4 pb-4 px-4 text-base items-center",
    attrs: {
      "data-tag": "search-header"
    }
  }, [_c("div", {
    staticClass: "flex-auto flex items-center h-8 py-1 px-3 bg-color-bg-4 rounded"
  }, [_c("IconSearch", {
    staticClass: "mr-1 fill-color-icon-disabled",
    attrs: {
      "custom-class": "h-4 w-4"
    }
  }), _c("input", {
    directives: [{
      name: "model",
      rawName: "v-model",
      value: _vm.state.search.input,
      expression: "state.search.input"
    }],
    staticClass: "h-5 flex-auto text-xs bg-transparent outline-0",
    attrs: {
      "placeholder": _vm.t("ui.select.pleaseSearch")
    },
    domProps: {
      "value": _vm.state.search.input
    },
    on: {
      "input": [function($event) {
        if ($event.target.composing)
          return;
        _vm.$set(_vm.state.search, "input", $event.target.value);
      }, _vm.searchMethod]
    }
  })], 1), _c("div", {
    staticClass: "flex items-center pl-3 cursor-pointer"
  }, [_c("div", {
    on: {
      "click": function click($event) {
        return _vm.searchBoxToggle(false);
      }
    }
  }, [_vm._v(_vm._s(_vm.t("ui.base.cancel")))])])]), _c("div", {
    staticClass: "flex-auto overflow-auto flex flex-col",
    attrs: {
      "data-tag": "search-body"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.search.filterOptions.length,
      expression: "state.search.filterOptions.length"
    }],
    class: ["flex flex-col px-4"]
  }, _vm._l(_vm.state.search.filterOptions, function(item, index) {
    return _c("xm-option", {
      key: index,
      attrs: {
        "multiple": _vm.multiple,
        "ellipsis": _vm.ellipsis,
        "text-field": _vm.textField,
        "text-field2": _vm.textField2,
        "text-field3": _vm.textField3,
        "option": item,
        "selected": _vm.isSelected(item)
      },
      on: {
        "click": function click($event) {
          return _vm.searchSelectHandler(item, index);
        }
      }
    }, [_vm.searchConfig.openSearchSlot ? _vm._t("search-item", null, {
      "item": item,
      "index": index
    }) : _vm._t("default", function() {
      return [_c("div", {
        class: ["flex-auto", {
          "truncate": _vm.ellipsis
        }]
      }, _vm._l(_vm.renderSearchOption(item[_vm.textField]), function(text, index2) {
        return _c("span", {
          key: index2
        }, [index2 ? _c("span", {
          staticClass: "text-color-brand"
        }, [_vm._v(_vm._s(_vm.state.search.input))]) : _vm._e(), _vm._v(_vm._s(text))]);
      }), 0)];
    }, {
      "item": item,
      "index": index
    })], 2);
  }), 1), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.search.input && !_vm.state.search.filterOptions.length,
      expression: "state.search.input && !state.search.filterOptions.length"
    }],
    staticClass: "w-full flex justify-center items-center text-center flex-auto"
  }, [_c("xm-exception", {
    attrs: {
      "component-page": "",
      "type": "noresult"
    }
  })], 1)])])])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var CascaderMobile = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
CascaderMobile.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
CascaderMobile.install = function(Vue) {
  Vue.component(CascaderMobile.name, CascaderMobile);
};
CascaderMobile.version = version;
export {
  CascaderMobile as default
};
